Bug 1762689 - [abrt] gnome-software: gs_flatpak_get_installation(): gnome-software killed by SIGSEGV
Summary: [abrt] gnome-software: gs_flatpak_get_installation(): gnome-software killed b...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: gnome-software
Version: 31
Hardware: x86_64
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Kalev Lember
QA Contact: Fedora Extras Quality Assurance
URL: https://retrace.fedoraproject.org/faf...
Whiteboard: abrt_hash:46e7ac38ea4f72dedb8f1601d88...
: 1763024 1764554 (view as bug list)
Depends On:
Blocks: F31FinalBlocker F31FinalFreezeException
TreeView+ depends on / blocked
 
Reported: 2019-10-17 09:13 UTC by Jonathan Haas
Modified: 2019-10-23 10:10 UTC (History)
11 users (show)

Fixed In Version: gnome-software-3.34.1-6.fc31
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-10-21 18:54:17 UTC


Attachments (Terms of Use)
File: backtrace (42.35 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: core_backtrace (17.87 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: cpuinfo (2.21 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: dso_list (18.32 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: environ (1.80 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: exploitable (100 bytes, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: limits (1.29 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: maps (119.86 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: mountinfo (2.86 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: open_fds (5.27 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: proc_pid_status (1.33 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details
File: var_log_messages (1.22 KB, text/plain)
2019-10-17 09:13 UTC, Jonathan Haas
no flags Details


Links
System ID Priority Status Summary Last Updated
GNOME Gitlab GNOME/gnome-software/issues/830 None None None 2019-10-17 09:27:33 UTC

Description Jonathan Haas 2019-10-17 09:13:15 UTC
Description of problem:
Gnome-Software randomly crashes in background very often

Version-Release number of selected component:
gnome-software-3.34.1-4.fc31

Additional info:
reporter:       libreport-2.10.1
backtrace_rating: 4
cgroup:         0::/user.slice/user-1000.slice/user@1000.service/gnome\x2dsession\x2dmanager.slice/gnome-session-manager@gnome.service
cmdline:        /usr/bin/gnome-software --gapplication-service
crash_function: gs_flatpak_get_installation
executable:     /usr/bin/gnome-software
journald_cursor: s=13241f1562a444e0986fdd7077c31397;i=4a1d5;b=05e8d9efbe264c44a847d0fe95ef74f9;m=c49f795;t=59516eb827933;x=5c8fd0922cde6fd6
kernel:         5.3.5-300.fc31.x86_64
rootdir:        /
runlevel:       N 5
type:           CCpp
uid:            1000

Truncated backtrace:
Thread no. 1 (8 frames)
 #0 gs_flatpak_get_installation at ../plugins/flatpak/gs-flatpak.c:2931
 #1 _build_transaction at ../plugins/flatpak/gs-plugin-flatpak.c:415
 #2 gs_plugin_download at ../plugins/flatpak/gs-plugin-flatpak.c:468
 #3 gs_plugin_loader_call_vfunc at ../lib/gs-plugin-loader.c:629
 #4 gs_plugin_loader_run_results at ../lib/gs-plugin-loader.c:1084
 #5 gs_plugin_loader_process_thread_cb at ../lib/gs-plugin-loader.c:3013
 #6 g_task_thread_pool_thread at ../gio/gtask.c:1410
 #8 g_thread_proxy at ../glib/gthread.c:805

Comment 1 Jonathan Haas 2019-10-17 09:13:19 UTC
Created attachment 1626738 [details]
File: backtrace

Comment 2 Jonathan Haas 2019-10-17 09:13:21 UTC
Created attachment 1626739 [details]
File: core_backtrace

Comment 3 Jonathan Haas 2019-10-17 09:13:22 UTC
Created attachment 1626740 [details]
File: cpuinfo

Comment 4 Jonathan Haas 2019-10-17 09:13:23 UTC
Created attachment 1626741 [details]
File: dso_list

Comment 5 Jonathan Haas 2019-10-17 09:13:24 UTC
Created attachment 1626742 [details]
File: environ

Comment 6 Jonathan Haas 2019-10-17 09:13:25 UTC
Created attachment 1626743 [details]
File: exploitable

Comment 7 Jonathan Haas 2019-10-17 09:13:27 UTC
Created attachment 1626744 [details]
File: limits

Comment 8 Jonathan Haas 2019-10-17 09:13:29 UTC
Created attachment 1626745 [details]
File: maps

Comment 9 Jonathan Haas 2019-10-17 09:13:30 UTC
Created attachment 1626746 [details]
File: mountinfo

Comment 10 Jonathan Haas 2019-10-17 09:13:31 UTC
Created attachment 1626747 [details]
File: open_fds

Comment 11 Jonathan Haas 2019-10-17 09:13:33 UTC
Created attachment 1626748 [details]
File: proc_pid_status

Comment 12 Jonathan Haas 2019-10-17 09:13:34 UTC
Created attachment 1626749 [details]
File: var_log_messages

Comment 13 Jonathan Haas 2019-10-17 09:20:40 UTC
Since a recent update of gnome-software, it crashes very often while running in background, often immediately after boot. This happens on multiple different systems by me. See also https://retrace.fedoraproject.org/faf/reports/2710719/

I haven't tested a clean install, but at the current state, this probably violates 
"There must be no [...] crash notifications [...] at first login after a default install of a release-blocking desktop."

Comment 15 Jonathan Haas 2019-10-17 10:06:54 UTC
Actually, it looks like that commit fixes the issue, but it hasn't made it to Fedora 31, yet.

Comment 16 Kamil Páral 2019-10-17 10:35:48 UTC
FWIW, I haven't seen this when operating just on RPMs. The traceback references flatpak, so I installed flathub repo into a clean F31 Workstation installation in VM, installed a few apps and rebooted several times, but I don't see any crash. It would be nice to figure out a more specific reproducer.

Comment 17 Jonathan Haas 2019-10-17 10:48:52 UTC
I'll try to find a reproducer on a clean system, but FWIW, on one affected system I've installed a lot of Flatpak apps, so that might be related:

$ flatpak list
Name                                                      Application ID                                         Version             Zweig                Ursprung                      Installation
Foliate                                                   com.github.johnfactotum.Foliate                        1.5.3               stable               flathub                       system
default                                                   org.freedesktop.Platform.GL.default                                        1.6                  gnome                         user
default                                                   org.freedesktop.Platform.GL.default                                        19.08                gnome-nightly                 system
default                                                   org.freedesktop.Platform.GL.default                                        19.08                gnome-nightly                 user
default                                                   org.freedesktop.Platform.GL.default                                        19.08beta            gnome-nightly                 system
default                                                   org.freedesktop.Platform.GL.default                                        19.08beta            gnome-nightly                 user
Adwaita icon theme                                        org.freedesktop.Platform.Icontheme.Adwaita                                 1.0                  flathub                       system
Adwaita icon theme                                        org.freedesktop.Platform.Icontheme.Adwaita                                 1.0                  gnome                         user
Intel VAAPI Driver                                        org.freedesktop.Platform.VAAPI.Intel                                       1.6                  flathub                       system
Intel VAAPI Driver                                        org.freedesktop.Platform.VAAPI.Intel                                       1.6                  gnome                         user
Intel                                                     org.freedesktop.Platform.VAAPI.Intel                                       18.08                flathub                       system
Intel                                                     org.freedesktop.Platform.VAAPI.Intel                                       19.08                gnome-nightly                 system
Intel                                                     org.freedesktop.Platform.VAAPI.Intel                                       19.08                gnome-nightly                 user
Intel                                                     org.freedesktop.Platform.VAAPI.Intel                                       19.08beta            gnome-nightly                 system
Intel                                                     org.freedesktop.Platform.VAAPI.Intel                                       19.08beta            gnome-nightly                 user
FFmpeg extension                                          org.freedesktop.Platform.ffmpeg                                            1.6                  flathub                       system
FFmpeg extension                                          org.freedesktop.Platform.ffmpeg                                            1.6                  gnome                         user
ffmpeg-html5                                              org.freedesktop.Platform.ffmpeg-html5                                      19.08beta            gnome-nightly                 system
ffmpeg-html5                                              org.freedesktop.Platform.ffmpeg-html5                                      19.08beta            gnome-nightly                 user
html5-codecs                                              org.freedesktop.Platform.html5-codecs                                      18.08                flathub                       system
GNU Image Manipulation Program                            org.gimp.GIMP                                          2.10.12             stable               flathub                       system
Builder                                                   org.gnome.Builder                                      3.34.0              master               gnome-apps-nightly            system
GNOME Application Platform version 3.20                   org.gnome.Platform                                                         3.20                 gnome                         user
GNOME Application Platform version 3.24                   org.gnome.Platform                                                         3.24                 gnome                         user
GNOME Application Platform version 3.28                   org.gnome.Platform                                                         3.28                 flathub                       system
GNOME Application Platform version 3.30                   org.gnome.Platform                                                         3.30                 flathub                       system
GNOME Application Platform version 3.32                   org.gnome.Platform                                                         3.32                 flathub                       system
GNOME Application Platform version 3.34                   org.gnome.Platform                                                         3.34                 flathub                       system
GNOME Application Platform version master                 org.gnome.Platform                                                         master               gnome-nightly                 system
Rezepte                                                   org.gnome.Recipes                                      2.0.2               stable               flathub                       system
GNOME Software Development Kit version 3.32               org.gnome.Sdk                                                              3.32                 flathub                       system
GNOME Software Development Kit version master             org.gnome.Sdk                                                              master               gnome-nightly                 system
GNOME Software Development Kit version master             org.gnome.Sdk                                                              master               gnome-nightly                 user
Docs                                                      org.gnome.Sdk.Docs                                                         3.32                 flathub                       user
Docs                                                      org.gnome.Sdk.Docs                                                         master               gnome-nightly                 user
Inkscape                                                  org.inkscape.Inkscape                                  0.92.4              stable               flathub                       system

Comment 18 Kamil Páral 2019-10-17 11:11:21 UTC
Looking at the list, this might be related to having the same application/runtime installed both system-wide and per-user.

Comment 19 Jonathan Haas 2019-10-17 14:43:24 UTC
I couldn't reproduce that easily with just installing a flatpak in --user and --system. It likely has to do with having an update available or something like that, which I have no idea how to reproduce easily as you need to install old versions on purpose. Or can someone who understands this code better than me analyze https://gitlab.gnome.org/GNOME/gnome-software/blob/3e1fe203b40248f571be2a804027acd8e23dc54e/plugins/flatpak/gs-plugin-flatpak.c#L440 and post under which conditions the variable `flatpak` will be NULL in line 468?

Comment 20 Adam Williamson 2019-10-17 19:56:06 UTC
Discussed at 2019-10-17 Fedora 31 go/no-go meeting, acting as a blocker review meeting: https://meetbot-raw.fedoraproject.org/fedora-meeting-1/2019-10-17/f31-final-go_no_go-meeting.2019-10-17-17.00.html . As we don't really have sufficient information on what causes this bug yet, we agreed to defer decision on blocker status until we have more information.

Comment 21 dovla091 2019-10-18 05:06:12 UTC
*** Bug 1763024 has been marked as a duplicate of this bug. ***

Comment 22 Jonathan Haas 2019-10-18 09:30:36 UTC
The conditions for the crash are according to Will Thompson:

* at least one Flatpak has an available update
* at least one non-Flatpak GsApp (e.g. an RPM) has an available update
* the last GsApp in the list happens to not be a Flatpak – as far as I know this is non-deterministic.

Comment 23 Kalev Lember 2019-10-18 12:09:18 UTC
I've backported the fix to gnome-software-3.34.1-6.fc31 (untested by me, but hopefully works).

Proposing as a FE as it's probably a good idea to pull this in through the freeze to avoid the updates process crashing.

Comment 24 Fedora Update System 2019-10-18 12:12:08 UTC
FEDORA-2019-6575577db7 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-6575577db7

Comment 25 Kamil Páral 2019-10-18 14:09:24 UTC
(In reply to Jonathan Haas from comment #22)
> The conditions for the crash are according to Will Thompson:
> 
> * at least one Flatpak has an available update
> * at least one non-Flatpak GsApp (e.g. an RPM) has an available update
> * the last GsApp in the list happens to not be a Flatpak – as far as I know
> this is non-deterministic.

I tried to reproduce this. On F31 VM, I installed ScummVM from Flathub using GNOME Software, and then downgraded it to an older version [1] using:

$ sudo flatpak update --commit=36c8229674e0180bf2137b58e14764a1493a5d671a95b6566ab772bba8d63c08 org.scummvm.ScummVM

Then I enabled updates-testing, which made a lot of RPM updates available. Rebooted, made GNOME Software recheck the updates, rebooted again and few more times still, but no crash occurred. Updated the RPMs, downgraded some of them, repeated the whole cycle, no crash. So unfortunately I can't verify the fix because I can't reproduce the error.

[1] https://github.com/flatpak/flatpak/wiki/Tips-&-Tricks#downgrading

Comment 26 Adam Williamson 2019-10-18 17:01:01 UTC
since we don't have any flatpaks installed in the live env or out of the box I'm not sure the FE case for this is super strong, but I think I'm a weak +1 FE just to make sure it's fixed for release if we test it and pull it in soon.

Comment 27 Jonathan Haas 2019-10-18 17:20:37 UTC
I can't reproduce the issue anymore after installing that updated rpm. Before it happened very reliably shortly after every login.

Comment 28 Fedora Update System 2019-10-18 17:36:05 UTC
gnome-software-3.34.1-6.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-6575577db7

Comment 29 Kevin Fenzi 2019-10-18 21:28:43 UTC
+1 FE

Comment 30 Stephen Gallagher 2019-10-18 21:47:20 UTC
I’m +1 FE for this.

Comment 31 Adam Williamson 2019-10-19 03:31:32 UTC
That's +3 FE, so setting acceptedFE.

Comment 32 Stephen Gallagher 2019-10-21 12:50:15 UTC
This was included in the RC 1.3 build and it appears to have fixed the issue for me and several others according to Bodhi, so I'd say that the blocker status of this is largely academic at this point.

That said, I'll vote -1 blocker on the grounds that while it's not a great user experience, it's also not actually impacting functionality and therefore would probably fail the "last blocker at Go/No-Go" test.

Comment 33 Adam Williamson 2019-10-21 15:51:25 UTC
setting to VERIFIED per #c32 (and bodhi comments).

Comment 34 Fedora Update System 2019-10-21 18:54:17 UTC
gnome-software-3.34.1-6.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 35 qirill 2019-10-23 10:10:47 UTC
*** Bug 1764554 has been marked as a duplicate of this bug. ***


Note You need to log in before you can comment on or make changes to this bug.